package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import org.antlr.analysis.DFA;
import org.antlr.codegen.CodeGenerator;
import org.antlr.tool.Grammar;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;

public abstract class SemanticContext {
  public static final org.antlr.analysis.SemanticContext EMPTY_SEMANTIC_CONTEXT = new Predicate(-2);
  
  public abstract org.antlr.analysis.SemanticContext getGatedPredicateContext();
  
  public abstract ST genExpr(CodeGenerator paramCodeGenerator, STGroup paramSTGroup, DFA paramDFA);
  
  public abstract boolean hasUserSemanticPredicate();
  
  public abstract boolean isSyntacticPredicate();
  
  public void trackUseOfSyntacticPredicates(Grammar g) {}
  
  public static org.antlr.analysis.SemanticContext and(org.antlr.analysis.SemanticContext a, org.antlr.analysis.SemanticContext b) {
    if (a instanceof FalsePredicate || b instanceof FalsePredicate)
      return new FalsePredicate(); 
    org.antlr.analysis.SemanticContext[] terms = factorOr(a, b);
    org.antlr.analysis.SemanticContext commonTerms = terms[0];
    a = terms[1];
    b = terms[2];
    boolean factored = (commonTerms != null && commonTerms != EMPTY_SEMANTIC_CONTEXT && !(commonTerms instanceof TruePredicate));
    if (factored)
      return or(commonTerms, and(a, b)); 
    if (a instanceof FalsePredicate || b instanceof FalsePredicate)
      return new FalsePredicate(); 
    if (a == EMPTY_SEMANTIC_CONTEXT || a == null)
      return b; 
    if (b == EMPTY_SEMANTIC_CONTEXT || b == null)
      return a; 
    if (a instanceof TruePredicate)
      return b; 
    if (b instanceof TruePredicate)
      return a; 
    AND result = new AND(a, b);
    if (result.operands.size() == 1)
      return result.operands.iterator().next(); 
    return result;
  }
  
  public static org.antlr.analysis.SemanticContext or(org.antlr.analysis.SemanticContext a, org.antlr.analysis.SemanticContext b) {
    if (a instanceof TruePredicate || b instanceof TruePredicate)
      return new TruePredicate(); 
    org.antlr.analysis.SemanticContext[] terms = factorAnd(a, b);
    org.antlr.analysis.SemanticContext commonTerms = terms[0];
    a = terms[1];
    b = terms[2];
    boolean factored = (commonTerms != null && commonTerms != EMPTY_SEMANTIC_CONTEXT && !(commonTerms instanceof FalsePredicate));
    if (factored)
      return and(commonTerms, or(a, b)); 
    if (a == EMPTY_SEMANTIC_CONTEXT || a == null || a instanceof FalsePredicate)
      return b; 
    if (b == EMPTY_SEMANTIC_CONTEXT || b == null || b instanceof FalsePredicate)
      return a; 
    if (a instanceof TruePredicate || b instanceof TruePredicate || commonTerms instanceof TruePredicate)
      return new TruePredicate(); 
    if (a instanceof NOT) {
      NOT n = (NOT)a;
      if (n.ctx.equals(b))
        return new TruePredicate(); 
    } else if (b instanceof NOT) {
      NOT n = (NOT)b;
      if (n.ctx.equals(a))
        return new TruePredicate(); 
    } 
    OR result = new OR(a, b);
    if (result.operands.size() == 1)
      return result.operands.iterator().next(); 
    return result;
  }
  
  public static org.antlr.analysis.SemanticContext not(org.antlr.analysis.SemanticContext a) {
    if (a instanceof NOT)
      return ((NOT)a).ctx; 
    if (a instanceof TruePredicate)
      return new FalsePredicate(); 
    if (a instanceof FalsePredicate)
      return new TruePredicate(); 
    return new NOT(a);
  }
  
  public static org.antlr.analysis.SemanticContext[] factorAnd(org.antlr.analysis.SemanticContext a, org.antlr.analysis.SemanticContext b) {
    if (a == EMPTY_SEMANTIC_CONTEXT || a == null || a instanceof FalsePredicate)
      return new org.antlr.analysis.SemanticContext[] { EMPTY_SEMANTIC_CONTEXT, a, b }; 
    if (b == EMPTY_SEMANTIC_CONTEXT || b == null || b instanceof FalsePredicate)
      return new org.antlr.analysis.SemanticContext[] { EMPTY_SEMANTIC_CONTEXT, a, b }; 
    if (a instanceof TruePredicate || b instanceof TruePredicate)
      return new org.antlr.analysis.SemanticContext[] { new TruePredicate(), EMPTY_SEMANTIC_CONTEXT, EMPTY_SEMANTIC_CONTEXT }; 
    HashSet<org.antlr.analysis.SemanticContext> opsA = new HashSet<org.antlr.analysis.SemanticContext>(getAndOperands(a));
    HashSet<org.antlr.analysis.SemanticContext> opsB = new HashSet<org.antlr.analysis.SemanticContext>(getAndOperands(b));
    HashSet<org.antlr.analysis.SemanticContext> result = new HashSet<org.antlr.analysis.SemanticContext>(opsA);
    result.retainAll(opsB);
    if (result.isEmpty())
      return new org.antlr.analysis.SemanticContext[] { EMPTY_SEMANTIC_CONTEXT, a, b }; 
    opsA.removeAll(result);
    if (opsA.isEmpty()) {
      a = new TruePredicate();
    } else if (opsA.size() == 1) {
      a = opsA.iterator().next();
    } else {
      a = new AND(opsA);
    } 
    opsB.removeAll(result);
    if (opsB.isEmpty()) {
      b = new TruePredicate();
    } else if (opsB.size() == 1) {
      b = opsB.iterator().next();
    } else {
      b = new AND(opsB);
    } 
    if (result.size() == 1)
      return new org.antlr.analysis.SemanticContext[] { result.iterator().next(), a, b }; 
    return new org.antlr.analysis.SemanticContext[] { new AND(result), a, b };
  }
  
  public static org.antlr.analysis.SemanticContext[] factorOr(org.antlr.analysis.SemanticContext a, org.antlr.analysis.SemanticContext b) {
    HashSet<org.antlr.analysis.SemanticContext> opsA = new HashSet<org.antlr.analysis.SemanticContext>(getOrOperands(a));
    HashSet<org.antlr.analysis.SemanticContext> opsB = new HashSet<org.antlr.analysis.SemanticContext>(getOrOperands(b));
    HashSet<org.antlr.analysis.SemanticContext> result = new HashSet<org.antlr.analysis.SemanticContext>(opsA);
    result.retainAll(opsB);
    if (result.isEmpty())
      return new org.antlr.analysis.SemanticContext[] { EMPTY_SEMANTIC_CONTEXT, a, b }; 
    opsA.removeAll(result);
    if (opsA.isEmpty()) {
      a = new FalsePredicate();
    } else if (opsA.size() == 1) {
      a = opsA.iterator().next();
    } else {
      a = new OR(opsA);
    } 
    opsB.removeAll(result);
    if (opsB.isEmpty()) {
      b = new FalsePredicate();
    } else if (opsB.size() == 1) {
      b = opsB.iterator().next();
    } else {
      b = new OR(opsB);
    } 
    if (result.size() == 1)
      return new org.antlr.analysis.SemanticContext[] { result.iterator().next(), a, b }; 
    return new org.antlr.analysis.SemanticContext[] { new OR(result), a, b };
  }
  
  public static Collection<org.antlr.analysis.SemanticContext> getAndOperands(org.antlr.analysis.SemanticContext context) {
    if (context instanceof AND)
      return ((AND)context).operands; 
    if (context instanceof NOT) {
      Collection<org.antlr.analysis.SemanticContext> operands = getOrOperands(((NOT)context).ctx);
      List<org.antlr.analysis.SemanticContext> list = new ArrayList<org.antlr.analysis.SemanticContext>(operands.size());
      for (org.antlr.analysis.SemanticContext operand : operands)
        list.add(not(operand)); 
      return list;
    } 
    ArrayList<org.antlr.analysis.SemanticContext> result = new ArrayList<org.antlr.analysis.SemanticContext>();
    result.add(context);
    return result;
  }
  
  public static Collection<org.antlr.analysis.SemanticContext> getOrOperands(org.antlr.analysis.SemanticContext context) {
    if (context instanceof OR)
      return ((OR)context).operands; 
    if (context instanceof NOT) {
      Collection<org.antlr.analysis.SemanticContext> operands = getAndOperands(((NOT)context).ctx);
      List<org.antlr.analysis.SemanticContext> list = new ArrayList<org.antlr.analysis.SemanticContext>(operands.size());
      for (org.antlr.analysis.SemanticContext operand : operands)
        list.add(not(operand)); 
      return list;
    } 
    ArrayList<org.antlr.analysis.SemanticContext> result = new ArrayList<org.antlr.analysis.SemanticContext>();
    result.add(context);
    return result;
  }
}
